﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Controls.Spreadsheet.Commands.Descriptors;
using Telerik.Windows.Controls.Spreadsheet.Core;

namespace TestWPF
{
    public class CommandDescriptorsBehaviour : ControlBase
    {
        public static CommandDescriptors GetCommandDescriptors(DependencyObject obj)
        {
            return (CommandDescriptors)obj.GetValue(CommandDescriptorsProperty);
        }

        public static void SetCommandDescriptors(DependencyObject obj, CommandDescriptors value)
        {
            obj.SetValue(CommandDescriptorsProperty, value);
        }

        public static readonly DependencyProperty CommandDescriptorsProperty =
            DependencyProperty.RegisterAttached("CommandDescriptors", typeof(CommandDescriptors), typeof(CommandDescriptorsBehaviour), new PropertyMetadata(OnPropertyChanged));


        public static ViewModel GetViewModel(DependencyObject obj)
        {
            return (ViewModel)obj.GetValue(ViewModelProperty);
        }

        public static void SetViewModel(DependencyObject obj, ViewModel value)
        {
            obj.SetValue(ViewModelProperty, value);
        }

        public static readonly DependencyProperty ViewModelProperty =
            DependencyProperty.RegisterAttached("ViewModel", typeof(ViewModel), typeof(CommandDescriptorsBehaviour), new PropertyMetadata(OnPropertyChanged));

 
        private static void OnPropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            ViewModel viewModel = CommandDescriptorsBehaviour.GetViewModel(d);
            if (viewModel != null)
            {
                viewModel.MyCommandDescriptors = CommandDescriptorsBehaviour.GetCommandDescriptors(d);
            }
        }
    }
}
