﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace TestWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        static MainWindow()
        {
        }

        public MainWindow()
        {
            InitializeComponent();

            this.LayoutRoot.DataContext = new ViewModel();
        }

        // Set visible size to the size of the Budget template
        int SpreadSheetColumns = 15;
        int SpreadSheetRows = 60;

        private void loadtemplate_Click(object sender, RoutedEventArgs e)
        {

            string templateFileName = @"..\Template.xlsx";

            if (!File.Exists(templateFileName))
            {
                // houston, we have a deployment problem
                throw new FileNotFoundException(String.Format("File {0} was not found!", templateFileName));
            }

            // load the Template File into the RAD Control
            IWorkbookFormatProvider formatProvider = new XlsxFormatProvider();
            using (FileStream input = new FileStream(templateFileName, FileMode.Open))
            {
                this.radSpreadsheet.Workbook = formatProvider.Import(input);
            }

            this.radSpreadsheet.ActiveSheet = this.radSpreadsheet.Workbook.Sheets["DataOwner"];



            this.radSpreadsheet.VisibleSize = new SizeI(SpreadSheetColumns, SpreadSheetRows);

            // Dont let the user see the sheet selector control or create new sheets
            Telerik.Windows.Controls.Spreadsheet.Controls.RadSpreadsheetSheetSelector.SetIsSheetSelectorVisible(this.radSpreadsheet, false);

            // Protect the Sheet (Template defines what fields are editable or not
            this.radSpreadsheet.Workbook.ActiveWorksheet.Protect(string.Empty, Telerik.Windows.Documents.Spreadsheet.Model.Protection.WorksheetProtectionOptions.Default);

        }
    }
}
